pipeline {
  environment {
    registry = "akanshagiriya/dashboard"
    registryCredential = 'Docker_cred'
    dockerImage = ''
  }
  agent any
  stages {
    stage('Building image') {
      steps{
        script {
          dockerImage = docker.build registry + ":$BUILD_NUMBER"
        }
      }
    }
    stage('Deploy Image') {
      steps{
        script {
          docker.withRegistry( '', registryCredential ) {
            dockerImage.push("$BUILD_NUMBER")
            dockerImage.push('latest')
          }
        }
      }
    }
    stage('Deploy') {
      steps{
        script {
          sh "docker stack rm dashboard || true"
          sh "docker stack deploy --prune --compose-file docker-compose.yml dashboard"
        }
      }
    }
  }
}
